/* zrpqlb.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer n1, n12, n13, n14, n15, n16;
} pp11r_;

#define pp11r_1 pp11r_

struct {
    real sr, si, u, v, ra, rb, c__, d__, a1, a2, a3, a6, a7, e, f, g, h__, 
            szr, szi, rlzr, rlzi, eta, are, rmre;
    integer n, nn;
} prpqlj_;

#define prpqlj_1 prpqlj_

/* Subroutine */ int zrpqlb_c(integer *l2, integer *nz, real *rab)
{
    /* Initialized data */

    static real zero = 0.f;

    /* System generated locals */
    integer i__1, i__2;
    real r__1;

    /* Local variables */
    static logical stry, vtry;
    static integer i__, j, iflag;
    static real s, betas, betav;
    static logical spass;
    static integer itype, i1, i2;
    static logical vpass;
    static real ui, vi, ss, ts, tv, vv;
    extern /* Subroutine */ int zrpqlc_c(real *, real *, integer *, real *),
            zrpqld_c(real *, integer *, integer *, real *), zrpqle_c(integer *,
            real *), zrpqlf_c(integer *, real *), zrpqlg_c(integer *, real *,
            real *, real *), zrpqlh_c(integer *, real *, real *, real *,
            real *, real *, real *);
    static real oss, ots, otv, tss, ovv, svu, svv, tvv;

    /* Parameter adjustments */
    --rab;

    /* Function Body */
    *nz = 0;
    betav = .25f;
    betas = .25f;
    oss = prpqlj_1.sr;
    ovv = prpqlj_1.v;
    zrpqlh_c(&prpqlj_1.nn, &prpqlj_1.u, &prpqlj_1.v, &rab[pp11r_1.n12 + 1],
            &rab[pp11r_1.n13 + 1], &prpqlj_1.ra, &prpqlj_1.rb);
    zrpqle_c(&itype, &rab[1]);
    i__1 = *l2;
    for (j = 1; j <= i__1; ++j) {
        zrpqlf_c(&itype, &rab[1]);
        zrpqle_c(&itype, &rab[1]);
        zrpqlg_c(&itype, &ui, &vi, &rab[1]);
        vv = vi;
        ss = 0.f;
        i1 = pp11r_1.n14 + prpqlj_1.n;
        i2 = pp11r_1.n12 + prpqlj_1.nn;
        if (rab[i1] != zero) {
            ss = -rab[i2] / rab[i1];
        }
        tv = 1.f;
        ts = 1.f;
        if (j == 1 || itype == 3) {
            goto L7;
        }
        if (vv != 0.f) {
            tv = (r__1 = (vv - ovv) / vv, abs(r__1));
        }
        if (ss != 0.f) {
            ts = (r__1 = (ss - oss) / ss, abs(r__1));
        }
        tvv = 1.f;
        if (tv < otv) {
            tvv = tv * otv;
        }
        tss = 1.f;
        if (ts < ots) {
            tss = ts * ots;
        }
        vpass = tvv < betav;
        spass = tss < betas;
        if (! (spass || vpass)) {
            goto L7;
        }
        svu = prpqlj_1.u;
        svv = prpqlj_1.v;
        i__2 = prpqlj_1.n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i1 = pp11r_1.n16 + i__;
            i2 = pp11r_1.n14 + i__;
/* L1: */
            rab[i1] = rab[i2];
        }
        s = ss;
        vtry = FALSE_;
        stry = FALSE_;
        if (spass && (! vpass || tss < tvv)) {
            goto L4;
        }
L2:
        zrpqlc_c(&ui, &vi, nz, &rab[1]);
        if (*nz > 0) {
            goto L9;
        }
        vtry = TRUE_;
        betav *= .25f;
        if (stry || ! spass) {
            goto L5;
        }
        i__2 = prpqlj_1.n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i1 = pp11r_1.n14 + i__;
            i2 = pp11r_1.n16 + i__;
/* L3: */
            rab[i1] = rab[i2];
        }
L4:
        zrpqld_c(&s, nz, &iflag, &rab[1]);
        if (*nz > 0) {
            goto L9;
        }
        stry = TRUE_;
        betas *= .25f;
        if (iflag == 0) {
            goto L5;
        }
        ui = -(s + s);
        vi = s * s;
        goto L2;
L5:
        prpqlj_1.u = svu;
        prpqlj_1.v = svv;
        i__2 = prpqlj_1.n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            i1 = pp11r_1.n14 + i__;
            i2 = pp11r_1.n16 + i__;
/* L6: */
            rab[i1] = rab[i2];
        }
        if (vpass && ! vtry) {
            goto L2;
        }
        zrpqlh_c(&prpqlj_1.nn, &prpqlj_1.u, &prpqlj_1.v, &rab[pp11r_1.n12 + 1],
                 &rab[pp11r_1.n13 + 1], &prpqlj_1.ra, &prpqlj_1.rb);
        zrpqle_c(&itype, &rab[1]);
L7:
        ovv = vv;
        oss = ss;
        otv = tv;
        ots = ts;
/* L8: */
    }
L9:
    return 0;
} /* zrpqlb_c */
