/* zrpqlc.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer n1, n12, n13, n14, n15, n16;
} pp11r_;

#define pp11r_1 pp11r_

struct {
    real sr, si, u, v, ra, rb, c__, d__, a1, a2, a3, a6, a7, e, f, g, h__, 
            szr, szi, rlzr, rlzi, eta, are, rmre;
    integer n, nn;
} prpqlj_;

#define prpqlj_1 prpqlj_

/* Subroutine */ int zrpqlc_c(real *uu, real *vv, integer *nz, real *rab)
{
    /* Initialized data */

    static real zero = 0.f;
    static real pt01 = .01f;
    static real one = 1.f;

    /* System generated locals */
    integer i__1;
    real r__1, r__2;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    static integer i__, j;
    static real t;
    static logical tried;
    static integer i1, itype;
    static real ee, ui, vi, zm, relstp;
    extern /* Subroutine */ int zrpqle_c(integer *, real *),
             zrpqlf_c(integer *,real *),
             zrpqlg_c(integer *, real *, real *, real *),
             zrpqlh_c(integer *, real *, real *, real *, real *, real *, real *),
             zrpqli_c(real *, real *, real *, real *, real *, real *, real *);
    static real omp, rmp;

    /* Parameter adjustments */
    --rab;

    /* Function Body */
    *nz = 0;
    tried = FALSE_;
    prpqlj_1.u = *uu;
    prpqlj_1.v = *vv;
    j = 0;
L1:
    zrpqli_c(&one, &prpqlj_1.u, &prpqlj_1.v, &prpqlj_1.szr, &prpqlj_1.szi,
            &prpqlj_1.rlzr, &prpqlj_1.rlzi);
    if ((r__1 = abs(prpqlj_1.szr) - abs(prpqlj_1.rlzr), abs(r__1)) > pt01 * 
            abs(prpqlj_1.rlzr)) {
        goto L6;
    }
    zrpqlh_c(&prpqlj_1.nn, &prpqlj_1.u, &prpqlj_1.v, &rab[pp11r_1.n12 + 1],
            &rab[pp11r_1.n13 + 1], &prpqlj_1.ra, &prpqlj_1.rb);
    rmp = (r__1 = prpqlj_1.ra - prpqlj_1.szr * prpqlj_1.rb, abs(r__1)) +
            (r__2 = prpqlj_1.szi * prpqlj_1.rb, abs(r__2));
    zm = (real)sqrt((real)(abs(prpqlj_1.v)));
    ee = (r__1 = rab[pp11r_1.n13 + 1], abs(r__1)) * 2.f;
    t = -prpqlj_1.szr * prpqlj_1.rb;
    i__1 = prpqlj_1.n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n13 + i__;
/* L2: */
        ee = ee * zm + (r__1 = rab[i1], abs(r__1));
    }
    ee = ee * zm + (r__1 = prpqlj_1.ra + t, abs(r__1));
    ee = (prpqlj_1.rmre * 5.f + prpqlj_1.are * 4.f) * ee - (prpqlj_1.rmre * 
            5.f + prpqlj_1.are * 2.f) * ((r__1 = prpqlj_1.ra + t, abs(r__1)) 
            + abs(prpqlj_1.rb) * zm) + prpqlj_1.are * 2.f * abs(t);
    if (rmp > ee * 20.f) {
        goto L3;
    }
    *nz = 2;
    goto L6;
L3:
    ++j;
    if (j > 20) {
        goto L6;
    }
    if (j < 2) {
        goto L5;
    }
    if (relstp > .01f || rmp < omp || tried) {
        goto L5;
    }
    if (relstp < prpqlj_1.eta) {
        relstp = prpqlj_1.eta;
    }
    relstp = (real)sqrt(relstp);
    prpqlj_1.u -= prpqlj_1.u * relstp;
    prpqlj_1.v += prpqlj_1.v * relstp;
    zrpqlh_c(&prpqlj_1.nn, &prpqlj_1.u, &prpqlj_1.v, &rab[pp11r_1.n12 + 1],
            &rab[pp11r_1.n13 + 1], &prpqlj_1.ra, &prpqlj_1.rb);
    for (i__ = 1; i__ <= 5; ++i__) {
        zrpqle_c(&itype, &rab[1]);
        zrpqlf_c(&itype, &rab[1]);
/* L4: */
    }
    tried = TRUE_;
    j = 0;
L5:
    omp = rmp;
    zrpqle_c(&itype, &rab[1]);
    zrpqlf_c(&itype, &rab[1]);
    zrpqle_c(&itype, &rab[1]);
    zrpqlg_c(&itype, &ui, &vi, &rab[1]);
    if (vi == zero) {
        goto L6;
    }
    relstp = (r__1 = (vi - prpqlj_1.v) / vi, abs(r__1));
    prpqlj_1.u = ui;
    prpqlj_1.v = vi;
    goto L1;
L6:
    return 0;
} /* zrpqlc_c */
