/* zrpqld.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer n1, n12, n13, n14, n15, n16;
} pp11r_;

#define pp11r_1 pp11r_

struct {
    real sr, si, u, v, ra, rb, c__, d__, a1, a2, a3, a6, a7, e, f, g, h__, 
            szr, szi, rlzr, rlzi, eta, are, rmre;
    integer n, nn;
} prpqlj_;

#define prpqlj_1 prpqlj_

/* Subroutine */ int zrpqld_c(real *sss, integer *nz, integer *iflag,
        real *rab)
{
    /* Initialized data */

    static real zero = 0.f;
    static real pt001 = .001f;

    /* System generated locals */
    integer i__1;
    real r__1;

    /* Local variables */
    static integer i__, j;
    static real s, t;
    static integer i1, i2, i3;
    static real ee, pv;
    static integer nm1;
    static real omp, rmp, rms, rkv;

    /* Parameter adjustments */
    --rab;

    /* Function Body */
    nm1 = prpqlj_1.n - 1;
    *nz = 0;
    s = *sss;
    *iflag = 0;
    j = 0;
L1:
    pv = rab[pp11r_1.n12 + 1];
    rab[pp11r_1.n13 + 1] = pv;
    i__1 = prpqlj_1.nn;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n12 + i__;
        i2 = pp11r_1.n13 + i__;
        pv = pv * s + rab[i1];
        rab[i2] = pv;
/* L2: */
    }
    rmp = abs(pv);
    rms = abs(s);
    ee = prpqlj_1.rmre / (prpqlj_1.are + prpqlj_1.rmre) * (r__1 =
            rab[pp11r_1.n13 + 1], abs(r__1));
    i__1 = prpqlj_1.nn;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n13 + i__;
/* L3: */
        ee = ee * rms + (r__1 = rab[i1], abs(r__1));
    }
    if (rmp > ((prpqlj_1.are + prpqlj_1.rmre) * ee - prpqlj_1.rmre * rmp) * 
            20.f) {
        goto L4;
    }
    *nz = 1;
    prpqlj_1.szr = s;
    prpqlj_1.szi = zero;
    goto L12;
L4:
    ++j;
    if (j > 10) {
        goto L12;
    }
    if (j < 2) {
        goto L5;
    }
    if (abs(t) > pt001 * (r__1 = s - t, abs(r__1)) || rmp <= omp) {
        goto L5;
    }
    *iflag = 1;
    *sss = s;
    goto L12;
L5:
    omp = rmp;
    rkv = rab[pp11r_1.n14 + 1];
    rab[pp11r_1.n15 + 1] = rkv;
    i__1 = prpqlj_1.n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n14 + i__;
        i2 = pp11r_1.n15 + i__;
        rkv = rkv * s + rab[i1];
        rab[i2] = rkv;
/* L6: */
    }
    i1 = pp11r_1.n14 + prpqlj_1.n;
    if (abs(rkv) <= (r__1 = rab[i1], abs(r__1)) * 10.f * prpqlj_1.eta) {
        goto L8;
    }
    t = -pv / rkv;
    rab[pp11r_1.n14 + 1] = rab[pp11r_1.n13 + 1];
    i__1 = prpqlj_1.n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n14 + i__;
        i2 = pp11r_1.n15 + i__ - 1;
        i3 = pp11r_1.n13 + i__;
/* L7: */
        rab[i1] = t * rab[i2] + rab[i3];
    }
    goto L10;
L8:
    rab[pp11r_1.n14 + 1] = zero;
    i__1 = prpqlj_1.n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n14 + i__;
        i2 = pp11r_1.n15 + i__ - 1;
/* L9: */
        rab[i1] = rab[i2];
    }
L10:
    rkv = rab[pp11r_1.n14 + 1];
    i__1 = prpqlj_1.n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n14 + i__;
/* L11: */
        rkv = rkv * s + rab[i1];
    }
    t = zero;
    i1 = pp11r_1.n14 + prpqlj_1.n;
    if (abs(rkv) > (r__1 = rab[i1], abs(r__1)) * 10.f * prpqlj_1.eta) {
        t = -pv / rkv;
    }
    s += t;
    goto L1;
L12:
    return 0;
} /* zrpqld_c */
