/* zp11r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer n1, n12, n13, n14, n15, n16;
} pp11r_;

#define pp11r_1 pp11r_

struct {
    real sr, si, u, v, ra, rb, c__, d__, a1, a2, a3, a6, a7, e, f, g, h__, 
            szr, szi, rlzr, rlzi, eta, are, rmre;
    integer n, nn;
} prpqlj_;

#define prpqlj_1 prpqlj_

/* Table of constant values */

static integer c__11 = 11;

/* Subroutine */ int zp11r_c(integer *np, real *a, real *root, real *rab,
        integer *ierr)
{
    /* Initialized data */

    static real sys063 = 2.f;
    static real zero = 0.f;
    static real one = 1.f;
    static real sys055 = 1.175495e-38f;
    static real sys059 = 3.4e38f;
    static real sys051 = 1.192093e-6f;
    static real sys053 = 3.4e38f;
    static real sys029 = .7071068f;

    /* System generated locals */
    integer i__1;
    real r__1;

    /* Builtin functions */
    double log(doublereal), pow_ri(real *, integer *), exp(doublereal);

    /* Local variables */
    static integer ndeg, icnt;
    static real cosr, rmax, rmin, sinr;
    static integer ndeg2, i__, j, l;
    static real t, x;
    static integer i1, j1, j2, i2;
    static logical zerok;
    static integer n2;
    extern /* Subroutine */ int utzp10_c(integer *, integer *);
    static real aa, bb, cc, df, ff;
    static integer jj;
    static real fn, sc, dx, xm;
    static integer nz;
    static real factor, xx, yy;
    extern /* Subroutine */ int zrpqlb_c(integer *, integer *, real *);
    static integer nm1;
    extern /* Subroutine */ int zrpqli_c(real *, real *, real *, real *,
            real *, real *, real *);
    static real bnd;
    static integer npi;
    static real rlo, xxx;

    /* Parameter adjustments */
    --rab;
    --root;
    --a;

    /* Function Body */
    ndeg = *np;
    prpqlj_1.n = ndeg;
    pp11r_1.n1 = prpqlj_1.n + 1;
    pp11r_1.n12 = pp11r_1.n1 + pp11r_1.n1;
    pp11r_1.n13 = pp11r_1.n12 + pp11r_1.n1;
    pp11r_1.n14 = pp11r_1.n13 + pp11r_1.n1;
    pp11r_1.n15 = pp11r_1.n14 + pp11r_1.n1;
    pp11r_1.n16 = pp11r_1.n15 + pp11r_1.n1;
    *ierr = 0;
    if (ndeg < 1) {
        goto L33;
    }
    prpqlj_1.eta = sys051;
    prpqlj_1.are = prpqlj_1.eta;
    prpqlj_1.rmre = prpqlj_1.eta;
    rlo = sys055 / prpqlj_1.eta;
    xx = sys029;
    yy = -xx;
    sinr = .9975641f;
    cosr = -.06975647f;
    prpqlj_1.nn = prpqlj_1.n + 1;
    j = 1;
    ndeg2 = ndeg + ndeg;
    if (a[prpqlj_1.nn] != zero) {
        goto L1;
    }
    *ierr = 66;
    goto L34;
L1:
    if (a[j] != zero) {
        goto L2;
    }
    root[j] = zero;
    jj = j + *np;
    root[jj] = zero;
    --prpqlj_1.nn;
    --prpqlj_1.n;
    ++j;
    if (j == *np + 1) {
        goto L35;
    }
    goto L1;
L2:
    i__1 = prpqlj_1.nn;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i1 = prpqlj_1.nn - i__ + pp11r_1.n12 + 1;
        i2 = i__ + j - 1;
        rab[i1] = a[i2];
/* L3: */
    }
L4:
    if (prpqlj_1.n > 2) {
        goto L6;
    }
    if (prpqlj_1.n < 1) {
        goto L35;
    }
    if (prpqlj_1.n == 2) {
        goto L5;
    }
    root[ndeg] = -rab[pp11r_1.n12 + 2] / rab[pp11r_1.n12 + 1];
    root[ndeg2] = zero;
    goto L29;
L5:
    zrpqli_c(&rab[pp11r_1.n12 + 1], &rab[pp11r_1.n12 + 2],
            &rab[pp11r_1.n12 +3], &root[ndeg - 1], &root[ndeg2 - 1],
            &root[ndeg], &root[ndeg2]);
    goto L29;
L6:
    rmax = 0.f;
    rmin = sys053;
    i__1 = prpqlj_1.nn;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n12 + i__;
        x = (r__1 = rab[i1], abs(r__1));
        if (x > rmax) {
            rmax = x;
        }
        if (x != 0.f && x < rmin) {
            rmin = x;
        }
/* L7: */
    }
    sc = rlo / rmin;
    if (sc > 1.f) {
        goto L8;
    }
    if (rmax < 10.f) {
        goto L11;
    }
    if (sc == 0.f) {
        sc = sys055 * sys063 * sys063;
    }
    goto L9;
L8:
    if (sys053 / sc < rmax) {
        goto L11;
    }
L9:
    l = (real)log(sc) / (real)log(sys063) + .5f;
    if (l == 0) {
        goto L11;
    }
    factor = (real)pow_ri(&sys063, &l);
    i__1 = prpqlj_1.nn;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n12 + i__;
/* L10: */
        rab[i1] = factor * rab[i1];
    }
L11:
    i__1 = prpqlj_1.nn;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n1 + i__;
        i2 = pp11r_1.n12 + i__;
/* L12: */
        rab[i1] = (r__1 = rab[i2], abs(r__1));
    }
    i1 = pp11r_1.n1 + prpqlj_1.nn;
    rab[i1] = -rab[i1];
    x = (real)exp((real)(((real)log((real)(-rab[i1])) -
            (real)log(rab[pp11r_1.n1 + 1])) / (real) prpqlj_1.n));
    i2 = pp11r_1.n1 + prpqlj_1.n;
    if (rab[i2] == 0.f) {
        goto L13;
    }
    xm = -rab[i1] / rab[i2];
    if (xm < x) {
        x = xm;
    }
L13:
    xm = x * .1f;
    ff = rab[pp11r_1.n1 + 1];
    i__1 = prpqlj_1.nn;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n1 + i__;
/* L14: */
        ff = ff * xm + rab[i1];
    }
    if (ff <= 0.f) {
        goto L15;
    }
    x = xm;
    goto L13;
L15:
    dx = x;
L16:
    if ((r__1 = dx / x, abs(r__1)) <= .005f) {
        goto L18;
    }
    ff = rab[pp11r_1.n1 + 1];
    df = ff;
    i__1 = prpqlj_1.n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n1 + i__;
        ff = ff * x + rab[i1];
        df = df * x + ff;
/* L17: */
    }
    i1 = pp11r_1.n1 + prpqlj_1.nn;
    ff = ff * x + rab[i1];
    dx = ff / df;
    x -= dx;
    goto L16;
L18:
    bnd = x;
    nm1 = prpqlj_1.n - 1;
    fn = one / (real) prpqlj_1.n;
    i__1 = prpqlj_1.n;
    for (i__ = 2; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n14 + i__;
        i2 = pp11r_1.n12 + i__;
/* L19: */
        rab[i1] = (real) (prpqlj_1.nn - i__) * rab[i2] * fn;
    }
    rab[pp11r_1.n14 + 1] = rab[pp11r_1.n12 + 1];
    i1 = pp11r_1.n12 + prpqlj_1.nn;
    i2 = pp11r_1.n12 + prpqlj_1.n;
    aa = rab[i1];
    bb = rab[i2];
    i1 = pp11r_1.n14 + prpqlj_1.n;
    zerok = rab[i1] == zero;
    for (jj = 1; jj <= 5; ++jj) {
        i1 = pp11r_1.n14 + prpqlj_1.n;
        cc = rab[i1];
        if (zerok) {
            goto L21;
        }
        t = -aa / cc;
        i__1 = nm1;
        for (i__ = 1; i__ <= i__1; ++i__) {
            j1 = prpqlj_1.nn - i__ + pp11r_1.n14;
            j2 = prpqlj_1.nn - i__ + pp11r_1.n12;
            rab[j1] = t * rab[j1 - 1] + rab[j2];
/* L20: */
        }
        rab[pp11r_1.n14 + 1] = rab[pp11r_1.n12 + 1];
        i1 = pp11r_1.n14 + prpqlj_1.n;
        zerok = (r__1 = rab[i1], abs(r__1)) <= abs(bb) * prpqlj_1.eta * 10.f;
        goto L23;
L21:
        i__1 = nm1;
        for (i__ = 1; i__ <= i__1; ++i__) {
            j = prpqlj_1.nn - i__ + pp11r_1.n14;
            rab[j] = rab[j - 1];
/* L22: */
        }
        rab[pp11r_1.n14 + 1] = zero;
        i1 = pp11r_1.n14 + prpqlj_1.n;
        zerok = rab[i1] == zero;
L23:
        ;
    }
    i__1 = prpqlj_1.n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n14 + i__;
/* L24: */
        rab[i__] = rab[i1];
    }
    for (icnt = 1; icnt <= 20; ++icnt) {
        xxx = cosr * xx - sinr * yy;
        yy = sinr * xx + cosr * yy;
        xx = xxx;
        prpqlj_1.sr = bnd * xx;
        prpqlj_1.si = bnd * yy;
        prpqlj_1.u = -prpqlj_1.sr - prpqlj_1.sr;
        prpqlj_1.v = bnd;
        i__1 = icnt * 20;
        zrpqlb_c(&i__1, &nz, &rab[1]);
        if (nz == 0) {
            goto L26;
        }
        j = ndeg - prpqlj_1.n + 1;
        jj = j + ndeg;
        root[j] = prpqlj_1.szr;
        root[jj] = prpqlj_1.szi;
        prpqlj_1.nn -= nz;
        prpqlj_1.n = prpqlj_1.nn - 1;
        i__1 = prpqlj_1.nn;
        for (i__ = 1; i__ <= i__1; ++i__) {
            i1 = pp11r_1.n12 + i__;
            i2 = pp11r_1.n13 + i__;
/* L25: */
            rab[i1] = rab[i2];
        }
        if (nz == 1) {
            goto L4;
        }
        root[j + 1] = prpqlj_1.rlzr;
        root[jj + 1] = prpqlj_1.rlzi;
        goto L4;
L26:
        i__1 = prpqlj_1.n;
        for (i__ = 1; i__ <= i__1; ++i__) {
            i1 = pp11r_1.n14 + i__;
/* L27: */
            rab[i1] = rab[i__];
        }
/* L28: */
    }
    *ierr = 67;
L29:
    i__1 = ndeg;
    for (i__ = 1; i__ <= i__1; ++i__) {
        npi = ndeg + i__;
        i1 = pp11r_1.n12 + i__;
        rab[i1] = root[npi];
/* L30: */
    }
    n2 = ndeg + ndeg;
    j = ndeg;
    i__1 = ndeg;
    for (i__ = 1; i__ <= i__1; ++i__) {
        i1 = pp11r_1.n12 + j;
        root[n2 - 1] = root[j];
        root[n2] = rab[i1];
        n2 += -2;
        --j;
/* L31: */
    }
    if (*ierr == 0) {
        goto L35;
    }
    n2 = (ndeg - prpqlj_1.nn << 1) + 3;
    i__1 = prpqlj_1.n;
    for (i__ = 1; i__ <= i__1; ++i__) {
        root[n2] = sys059;
        root[n2 + 1] = sys059;
        n2 += 2;
/* L32: */
    }
    goto L34;
L33:
    *ierr = 65;
L34:
    if (*ierr != 0) {
        utzp10_c(ierr, &c__11);
    }
L35:
    return 0;
} /* zp11r_c */
