/* zrpqlg.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Common Block Declarations */

struct {
    integer n1, n12, n13, n14, n15, n16;
} pp11r_;

#define pp11r_1 pp11r_

struct {
    real sr, si, u, v, ra, rb, c__, d__, a1, a2, a3, a6, a7, e, f, g, h__, 
            szr, szi, rlzr, rlzi, eta, are, rmre;
    integer n, nn;
} prpqlj_;

#define prpqlj_1 prpqlj_

/* Subroutine */ int zrpqlg_c(integer *itype, real *uu, real *vv, real *rab)
{
    /* Initialized data */

    static real zero = 0.f;

    static real temp, a4, a5, c1;
    static integer i1, i2, i3;
    static real c2, c3, c4, b1, b2;

    /* Parameter adjustments */
    --rab;

    /* Function Body */
    if (*itype == 3) {
        goto L3;
    }
    if (*itype == 2) {
        goto L1;
    }
    a4 = prpqlj_1.ra + prpqlj_1.u * prpqlj_1.rb + prpqlj_1.h__ * prpqlj_1.f;
    a5 = prpqlj_1.c__ + (prpqlj_1.u + prpqlj_1.v * prpqlj_1.f) * prpqlj_1.d__;
    goto L2;
L1:
    a4 = (prpqlj_1.ra + prpqlj_1.g) * prpqlj_1.f + prpqlj_1.h__;
    a5 = (prpqlj_1.f + prpqlj_1.u) * prpqlj_1.c__ + prpqlj_1.v * prpqlj_1.d__;
L2:
    i1 = pp11r_1.n14 + prpqlj_1.n;
    i2 = pp11r_1.n12 + prpqlj_1.nn;
    i3 = pp11r_1.n12 + prpqlj_1.n;
    b1 = -rab[i1] / rab[i2];
    b2 = -(rab[i1 - 1] + b1 * rab[i3]) / rab[i2];
    c1 = prpqlj_1.v * b2 * prpqlj_1.a1;
    c2 = b1 * prpqlj_1.a7;
    c3 = b1 * b1 * prpqlj_1.a3;
    c4 = c1 - c2 - c3;
    temp = a5 + b1 * a4 - c4;
    if (temp == zero) {
        goto L3;
    }
    *uu = prpqlj_1.u - (prpqlj_1.u * (c3 + c2) + prpqlj_1.v * (b1 * 
            prpqlj_1.a1 + b2 * prpqlj_1.a7)) / temp;
    *vv = prpqlj_1.v * (c4 / temp + 1);
    goto L4;
L3:
    *uu = zero;
    *vv = zero;
L4:
    return 0;
} /* zrpqlg_c */
